library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity SyncDownCounter is

    port (
        clk, enable, load : in std_logic;
		d_in : in std_logic_vector(3 downto 0);
        d_out : out std_logic_vector(3 downto 0)
    );

end SyncDownCounter;

architecture std of SyncDownCounter is

	signal w_counter : std_logic_vector(3 downto 0);

begin

	process(clk)
		variable counter : unsigned(3 downto 0);
	begin
		if('1' = load) then
			counter := unsigned(d_in);
		elsif(rising_edge(clk) and ('1' = enable)) then
			counter := counter - x"1";
		end if;

		w_counter <= std_logic_vector(counter);
	end process;

	d_out <= w_counter;

end std;
